// A Sample RPG Game starter by Griswald (griswald@adah.zzn.com)


// Authors Note: Some of this code might be poorly written. It's more or less just thrown together to
//    show you how to do certain things. Normally, code should always be VERY well organized. Not just put into one big 'ol file.
//                      -- Griswald --

// Side Note:   Saving / Loading of characters is not supported. This is just to show you how to do stuff.

world
	hub = "Griswald.RPGEnlightenment"  // Uncomment the first to slashes and replace this with what the hub says to
	name = "RPG Enlightenment, Griswald shows how to do certain things people wanna know."
	view = 6  // This is the size of the image screen (6x6 tiles)

	New() // after a certain ammount of time the world will refresh with this code, including monsters, and items!
		spawn // The repop rate is 30 seconds. (for every ten in a sleep statement, it's 1 second)
			while(1)
				sleep(300)
				for(var/obj in world)
				for(var/mob/M in world)
					sleep(520)
					Repop()
					world << "<font color=\"blue\">*** <font color=\"green\">Repop <font color=\"blue\">***"



		statpanel("Inventory")  // Stat panel for characters inventory
		stat(src.contents) // Show what char has in their inventory




mob
	verb // Now for player verbs
		Who() // A simple who command
			for(var/mob/M in world) // a for loop that checks every mob in the game
				if (M.client) // make sure the mob is a player
					usr << "[M.name] (Key: [M.key])" // I'm sure you can guess what it looks like. ;)

		WorldTalk(msg as text) // Now.. how about gossip amidst players?
			world << "(WorldTalk) \icon[usr] [usr.name]: [msg]" // Shows what the person looks like, prints their name, and also the message.



		Credits()  // This is so that all proper credit is given and can be viewed at anytime.
			usr << "[world.name] is (c) \[Insert year here] by \[Insert yourname here]"
			usr << ""
			usr << "<hr>"
			usr << "This game uses the RPG Enlightenment system by Griswald as a foundation." // Please do not remove this line.

	proc  // This stands for "process", which is simply a 'handler' type of program. Use procs as function calls for your if checks, etc.
		die(mob/M in world) // kill one player, which is specified when you call it. I.E. Later on, look for die(usr), and other things
			world << "[M] has been killed by [usr]!"  // world << msg is the format for sending to everyone in the game. [M] gets replaced with the mob's name.
			if (!M.client) // ! is a universal programming character that means "NOT", anotherwards if NOT M.client (to make sure it's not a player)
				del(M)  // Indentation is the key to BYOND programming
			else
				M.loc = locate(1,1,1)  // Relocate the player. Locate's format is like this: locate(x,y,z). X/Y are the coordinates and Z is the map number.
				M.health = 10  // Give the player a small portion of their health upon death.
			usr.experience += rand(1,10) // gain some experience
			checklevel(usr) // see if the player raises a level

		checklevel(mob/M in world) // The process that makes the character gain a level, etc.
			if (M.experience >= M.experiencetolevel)
				M.experience = 0
				M.experiencetolevel *= 2
				M << "You gain a level!"
				M.level += 1
				var/hpgain = rand(1,10)
				M.health += hpgain
				M.maxhealth += hpgain

		damage(mob/M in world)	// This isn't gonna be really advanced... just a simple damage doer. No advanced stuff here like calculating defense into it, etc.
			var/dam = rand(1,usr.strength)  // dam is a variable and is now defined with a random number between 1 through 10

			dam -= rand(1,M.defense) // small algorithm. ;)

			if (dam > 0)
				M.health -= dam   // subtract the damage from the victim's health
				view(6) << "[usr] attacks [M] for [dam] health!" // sends a message to anyone on your screen
			else
				view(6) << "[usr] attacks [M] but MISSES!"

			if (M.health <= 0)  // Is the character's health less then or equal to 0?
				die(M)   // As defined earlier, kill the victim. :D

	Admin  // A MOB define, however, there are no "ADMIN" mobs. This is so everyone dosen't get GM (Game Master) commands.
		verb // "Verb", or a command that the characters can actually use.
			InstantKill(mob/M in world) // defined same way procs are
				set name = "Instant Kill"
				set desc = "Instantly kill someone"
				set category = "GM"
				world << "The gods grin mischiviously from above... [M] suddenly clutches their chest, and falls down... dead." // Roleplayish enough? :D  Well... my spelling isn't the best...
				die(M) // kill that unsuspecting player >=)

			RestoreAll()
				set name = "Restore All" // Define how it appears in the commands window
				set desc = "Restores everyone in the game." // Defines what this command does.
				set category = "GM" // What 'tab' does it appear under? in this case, it's the GM tab.
				world << "The gods smile down upon your soul... You feel your as though your body is lighter."
				for(var/mob/M in world) // this is a 'for' loop that will go through EVERY mob in the game.
					if (M.client)  // this way, it only restores players, not NPC's.
						M.health = M.maxhealth // Self explanatory =)

			Boot(mob/M in world)
				set name = "Boot"
				set desc = "Kick someone from the game"
				set category = "GM"
				if (M.client)
					M << "The gods decided to kick you from the realms..."
					usr << "[M] has been booted from the game."
					del(M)
				else
					usr << "Why boot an NPC?"
					return

			// Please note, I know this isn't a lot of GM commands. I didn't intend their to be alot.
			// Go take a look at Spuzzum's s_admin code and port some of them over. It REALLY isn't
			// hard to do at all. If anything, just ask a friend to do it for you.
			//                                                  -- Griswald --


